PingOne Platform APIs - Early Access

Test Authorization Attribute

 

POST {{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}

The POST /environments/{{envID}}/authorizationAttributes/{{authAttributeID}}` request tests the authorization attribute specified by its ID in the request URL.

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/vnd.pingidentity.authorize.test+json

Body

raw ( application/vnd.pingidentity.authorize.test+json )

{
  "parameters": [
    {
      "key": "Request.AccountNo",
      "value": "Customer2987"
    }
  ],
  "userContext": {
    "user": {
      "id": "{{userID}}"
    }
  },
  "overrides": [
    {
      "type": "ATTRIBUTE",
      "value": {
        "id": "{{authAttributeID}}",
        "override": "ABC"
      }
    }
  ]
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}' \
--header 'Content-Type: application/vnd.pingidentity.authorize.test+json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "parameters": [
    {
      "key": "Request.AccountNo",
      "value": "Customer2987"
    }
  ],
  "userContext": {
    "user": {
      "id": "{{userID}}"
    }
  },
  "overrides": [
    {
      "type": "ATTRIBUTE",
      "value": {
        "id": "{{authAttributeID}}",
        "override": "ABC"
      }
    }
  ]
}'
var options = new RestClientOptions("{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.authorize.test+json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"  ""parameters"": [" + "\n" +
@"    {" + "\n" +
@"      ""key"": ""Request.AccountNo""," + "\n" +
@"      ""value"": ""Customer2987""" + "\n" +
@"    }" + "\n" +
@"  ]," + "\n" +
@"  ""userContext"": {" + "\n" +
@"    ""user"": {" + "\n" +
@"      ""id"": ""{{userID}}""" + "\n" +
@"    }" + "\n" +
@"  }," + "\n" +
@"  ""overrides"": [" + "\n" +
@"    {" + "\n" +
@"      ""type"": ""ATTRIBUTE""," + "\n" +
@"      ""value"": {" + "\n" +
@"        ""id"": ""{{authAttributeID}}""," + "\n" +
@"        ""override"": ""ABC""" + "\n" +
@"      }" + "\n" +
@"    }" + "\n" +
@"  ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}"
  method := "POST"

  payload := strings.NewReader(`{
  "parameters": [
    {
      "key": "Request.AccountNo",
      "value": "Customer2987"
    }
  ],
  "userContext": {
    "user": {
      "id": "{{userID}}"
    }
  },
  "overrides": [
    {
      "type": "ATTRIBUTE",
      "value": {
        "id": "{{authAttributeID}}",
        "override": "ABC"
      }
    }
  ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/vnd.pingidentity.authorize.test+json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /environments/{{envID}}/authorizationAttributes/{{authAttributeID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/vnd.pingidentity.authorize.test+json
Authorization: Bearer {{accessToken}}

{
  "parameters": [
    {
      "key": "Request.AccountNo",
      "value": "Customer2987"
    }
  ],
  "userContext": {
    "user": {
      "id": "{{userID}}"
    }
  },
  "overrides": [
    {
      "type": "ATTRIBUTE",
      "value": {
        "id": "{{authAttributeID}}",
        "override": "ABC"
      }
    }
  ]
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.authorize.test+json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"parameters\": [\n    {\n      \"key\": \"Request.AccountNo\",\n      \"value\": \"Customer2987\"\n    }\n  ],\n  \"userContext\": {\n    \"user\": {\n      \"id\": \"{{userID}}\"\n    }\n  },\n  \"overrides\": [\n    {\n      \"type\": \"ATTRIBUTE\",\n      \"value\": {\n        \"id\": \"{{authAttributeID}}\",\n        \"override\": \"ABC\"\n      }\n    }\n  ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}")
  .method("POST", body)
  .addHeader("Content-Type", "application/vnd.pingidentity.authorize.test+json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/vnd.pingidentity.authorize.test+json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "parameters": [
      {
        "key": "Request.AccountNo",
        "value": "Customer2987"
      }
    ],
    "userContext": {
      "user": {
        "id": "{{userID}}"
      }
    },
    "overrides": [
      {
        "type": "ATTRIBUTE",
        "value": {
          "id": "{{authAttributeID}}",
          "override": "ABC"
        }
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}',
  'headers': {
    'Content-Type': 'application/vnd.pingidentity.authorize.test+json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "parameters": [
      {
        "key": "Request.AccountNo",
        "value": "Customer2987"
      }
    ],
    "userContext": {
      "user": {
        "id": "{{userID}}"
      }
    },
    "overrides": [
      {
        "type": "ATTRIBUTE",
        "value": {
          "id": "{{authAttributeID}}",
          "override": "ABC"
        }
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}"

payload = json.dumps({
  "parameters": [
    {
      "key": "Request.AccountNo",
      "value": "Customer2987"
    }
  ],
  "userContext": {
    "user": {
      "id": "{{userID}}"
    }
  },
  "overrides": [
    {
      "type": "ATTRIBUTE",
      "value": {
        "id": "{{authAttributeID}}",
        "override": "ABC"
      }
    }
  ]
})
headers = {
  'Content-Type': 'application/vnd.pingidentity.authorize.test+json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/vnd.pingidentity.authorize.test+json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "parameters": [\n    {\n      "key": "Request.AccountNo",\n      "value": "Customer2987"\n    }\n  ],\n  "userContext": {\n    "user": {\n      "id": "{{userID}}"\n    }\n  },\n  "overrides": [\n    {\n      "type": "ATTRIBUTE",\n      "value": {\n        "id": "{{authAttributeID}}",\n        "override": "ABC"\n      }\n    }\n  ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.authorize.test+json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "parameters": [
    {
      "key": "Request.AccountNo",
      "value": "Customer2987"
    }
  ],
  "userContext": {
    "user": {
      "id": "{{userID}}"
    }
  },
  "overrides": [
    {
      "type": "ATTRIBUTE",
      "value": {
        "id": "{{authAttributeID}}",
        "override": "ABC"
      }
    }
  ]
})

response = http.request(request)
puts response.read_body
let parameters = "{\n  \"parameters\": [\n    {\n      \"key\": \"Request.AccountNo\",\n      \"value\": \"Customer2987\"\n    }\n  ],\n  \"userContext\": {\n    \"user\": {\n      \"id\": \"{{userID}}\"\n    }\n  },\n  \"overrides\": [\n    {\n      \"type\": \"ATTRIBUTE\",\n      \"value\": {\n        \"id\": \"{{authAttributeID}}\",\n        \"override\": \"ABC\"\n      }\n    }\n  ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/environments/{{envID}}/authorizationAttributes/{{authAttributeID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.authorize.test+json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
  "elapsedMicroseconds": 949,
  "request": {
    "parameters": [
      {
        "key": "PingOne.API Access Management.Remote API Server 1",
        "value": "Customer2987"
      }
    ],
    "userContext": {
      "user": {
        "id": "59b11a3f-d8a4-48ae-bd05-c4b3c43c490b"
      }
    },
    "overrides": [
      {
        "type": "ATTRIBUTE",
        "value": {
          "id": "746aba7f-2daa-4bf4-8597-3014200a26cb",
          "override": "ABC"
        }
      }
    ]
  },
  "authorized": false,
  "status": {
    "code": "OKAY",
    "messages": ""
  },
  "result": {
    "value": "abc",
    "type": "String"
  }
}